/*
 *  AunderB.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/19/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int AunderB(const gsl_matrix * A, const gsl_matrix * B, gsl_matrix * result)
{
    int j ;
    gsl_matrix * LocalA = gsl_matrix_calloc(A->size1,A->size2) ;
	gsl_permutation * P = gsl_permutation_calloc(A->size1);
	int signum ;
	
    gsl_matrix_memcpy(LocalA,A) ;
	gsl_linalg_LU_decomp(LocalA,P,&signum);
	
    for (j = 0 ; j < result->size2 ; j++)
    {
        gsl_vector_const_view b_j = gsl_matrix_const_column(B,j) ;
        gsl_vector_view res_j = gsl_matrix_column(result,j) ;
        gsl_linalg_LU_solve(LocalA, P, &b_j.vector, &res_j.vector) ;
    }
    
    gsl_matrix_free(LocalA) ;
	gsl_permutation_free(P);
	return 0 ;
}
