/*
 *  CalculateCellProbs.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/20/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int CalculateCellProbs(MissBin * MB)
{
	int i;
	
	for (i=0;i<MB->lamhat->size1;i++)
	{
		double probs[3] = {0.0, 0.0, 0.0} ;
		double Ri = MB->R->data[i] ;
		double lam1 = MB->lamhat->data[i*MB->lamhat->tda + 0] ;
		double lam2 = MB->lamhat->data[i*MB->lamhat->tda + 1] ;
		
		probs[0] = lam1 ;
		if (Ri > 1.5) 
		{
			probs[1] = (1.0 - lam1) * lam2 ;
			if (Ri > 2.5) probs[2] = (1.0 - lam1) * (1.0 - lam2) ;
		}
		/*
		if (i < 25)
		{
		printf("R[%d] = %3.f, K = (%4.1f, %4.1f, %4.1f)\n", i, Ri, probs[0], probs[1], probs[2]);
		}
		*/
		
	}
	
	return 0 ;
}

