/*
 *  EstimateProjReduced.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/29/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int EstimateProjReduced(gsl_vector * proj_red, gsl_vector * beta_old, int d_old, int * non0ind_old, 
	MissBin * MB)
{
	size_t d = MB->X->size2 ;
	gsl_vector * beta_long = gsl_vector_calloc(d);
	gsl_vector * proj_long = gsl_vector_calloc(d);
	int j;
	
	//printf("EstimateProjReduced\n");
	for (j=0;j<d_old;j++) beta_long->data[*(non0ind_old+j)] = *(beta_old->data+j);
	//baj_print_vector(beta_long);
	EstimateL2Projection(proj_long,beta_long,MB);
	//baj_print_vector(proj_long);
	
	//gsl_vector_set_zero(proj_red);
	for (j=0;j<d_old;j++) 
	{
		int tmp_ind = *(non0ind_old+j) ;
		proj_red->data[j] = proj_long->data[tmp_ind] ;
	}
	
	gsl_vector_free(beta_long);
	gsl_vector_free(proj_long);
	
	return 0 ;
}

