/*
 *  EstimateVarBhatEff.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/30/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int EstimateVarBhatEff(gsl_vector * sehat, gsl_vector * bhat, gsl_vector * Yc, 
	gsl_matrix * Xc, gsl_vector * wtc, MissBin * MB)
{
	size_t d = MB->G->size2 ;	
	size_t n = MB->G->size1 ;
	gsl_matrix * I0 = gsl_matrix_calloc(d,d);
	gsl_matrix * I1 = gsl_matrix_calloc(d,d);
	gsl_matrix * V = gsl_matrix_calloc(d,d);
	int j ;
	
	EstimateVhatEffGradient(I0,Yc,Xc,wtc,MB);
	EstimateVhatEffScoreVar(I1,bhat,MB);
	/*
	printf("I0 = \n");
	baj_print_matrix(I0);
	printf("I1 = \n");
	baj_print_matrix(I1);
	*/
	
	SandwichEstimate(V,I0,I1);
	
	for (j=0;j<d;j++)
	{
		double v = V->data[j*V->tda + j] ;
		sehat->data[j] = sqrt(v);
		//sehat->data[j] = sqrt(v/n);
	}
	
	gsl_matrix_free(I0);
	gsl_matrix_free(I1);
	gsl_matrix_free(V);
	
	
	return 0 ;
}

