/*
 *  EstimateVhatEffGradient.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/30/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int EstimateVhatEffGradient(gsl_matrix * I0, gsl_vector * Yc, gsl_matrix * Xc, gsl_vector * wtc, 
	MissBin * MB)
{
	int i ;
	size_t nc = Xc->size1 ;
	size_t d = Xc->size2 ;
	gsl_matrix * W = gsl_matrix_calloc(nc,nc);
	gsl_matrix * WX = gsl_matrix_calloc(nc,d);
	gsl_matrix * XtWX = gsl_matrix_calloc(d,d);
	
	for (i=0;i<nc;i++) W->data[i*W->tda + i] = wtc->data[i] ;
	
	gsl_blas_dgemm(CblasNoTrans,CblasNoTrans,1.0,W,Xc,0.0,WX);
	gsl_blas_dgemm(CblasTrans,CblasNoTrans,1.0,Xc,WX,0.0,XtWX);
	
	gsl_matrix_memcpy(I0,XtWX);
	
	gsl_matrix_free(W);
	gsl_matrix_free(WX);
	gsl_matrix_free(XtWX);
	return 0;
}

