/*
 *  EstimateVhatEffScoreVar.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/30/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int EstimateVhatEffScoreVar(gsl_matrix * I1, gsl_vector * beta, MissBin * MB)
{
	size_t n = MB->G->size1 ;
	size_t d = MB->G->size2 ;
	gsl_matrix * D = gsl_matrix_calloc(n,d);
	gsl_matrix * I1_local = gsl_matrix_calloc(d,d);
	int i,j,k ;
	
	GetScoreEffFullMatrix(D,beta,MB);
	
	for (i=0;i<n;i++)
	{
		for (j=0;j<d;j++) 
		{
			double dj = D->data[i*D->tda + j] ;
			for (k=0;k<d;k++) 
			{
				I1_local->data[j * I1_local->tda + k] += dj * D->data[i*D->tda + k] ;
			}
		}
	}
	
	gsl_matrix_memcpy(I1,I1_local);
	
	gsl_matrix_free(I1_local);
	gsl_matrix_free(D);
	return 0 ;
}
