/*
 *  EvalPbeta.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/21/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

double EvalPbeta(double lambda, double a1, double abj, int METH)
{
    double value = 0.0 ;
    switch (METH)
    {
        case 0 : // scad
        {
            if (abj<=lambda) value = 1.0 ;
            else 
            {
                if (abj< (a1*lambda)) value = (a1*lambda - abj)/((a1-1)*lambda) ;
            }
            break ;
        }
        case 1 : // hard
        {
            if (abj<=lambda) value = -2.0*(abj-lambda) ;
            break ;
        }
        case 2 : // lasso
        {
            value = 1.0 ;
            break ;
        }
        default :
        printf("Unknown call to METH\n") ;
        exit(8) ;
        
    }
    
    return value ;
}
