/*
 *  EvalPbeta2.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/8/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int EvalnSigmaU2(gsl_matrix * nSigmaU, double lambda, double a1, gsl_vector * beta, int METH, double n, 
	gsl_vector * b0)
{
    int j ;
    size_t d = nSigmaU->size1 ;
    double epsMM = 1.0E-6 ;
	
    for (j=0;j<d;j++)
    {
        double bj = beta->data[j];
        double abj = baj_abs(bj) ;
		double pbetaj = 0.0 ;
		
		if (METH<3) pbetaj = EvalPbeta(lambda, a1, abj, METH);
		else if (METH==3) pbetaj = 1.0/baj_abs(b0->data[j]) ;
        
		nSigmaU->data[j*nSigmaU->tda + j] = n*lambda*pbetaj/(epsMM+abj) ;
    }

    return 0 ;
}
