/*
 *  FindPenStdErrorsOLSFull.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/21/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int FindPenStdErrorsOLSFull(gsl_vector * se, gsl_vector * b, int * non0ind_new, int d_new, 
	gsl_vector * Y, gsl_matrix * X, double lambda, int METH)
{
    size_t d = b->size;
    size_t n = Y->size;
    gsl_vector * bred = gsl_vector_calloc(d_new);
    gsl_matrix * RedX = gsl_matrix_calloc(n,d_new) ;
    gsl_matrix * nSigmaU = gsl_matrix_calloc(d_new, d_new) ;
    gsl_matrix * RedXtX = gsl_matrix_calloc(d_new, d_new);
    gsl_matrix * V = gsl_matrix_calloc(d_new, d_new);
    gsl_vector * yhat = gsl_vector_calloc(n);
    int i,j;
    double sse=0.0;
	double mse=0.0;
    
    // MSE
    gsl_blas_dgemv(CblasNoTrans, 1.0, X, b, 0.0, yhat) ;
    sse=0.0;
    for (i=0;i<n;i++) 
	{
		sse += pow(Y->data[i]-yhat->data[i], 2.0);
	}
    mse = sse/((double) (n - d)) ;
    
    for (j=0;j<d_new;j++) 
	{
		bred->data[j] = b->data[*(non0ind_new+j)] ; // Reduced bhat
	}
    GetReducedX(RedX, non0ind_new, d_new, X) ; // Reduced X

    EvalnSigmaU(nSigmaU, lambda, 3.7, bred, METH, (double) n) ; // Find nSigmaU
    
    gsl_blas_dgemm(CblasTrans, CblasNoTrans, 1.0, RedX, RedX, 0.0, RedXtX) ; // X'X
    gsl_matrix_add(nSigmaU, RedXtX) ; // (X'X + nSigmaU)
	
	SandwichEstimate(V,nSigmaU,RedXtX);
    
    gsl_vector_set_zero(se);
    for (j=0;j<d_new;j++)
    {
        int indj = *(non0ind_new+j) ;
        double sisj = mse * V->data[j * V->tda + j] ;
        se->data[indj] = sqrt(sisj) ;
    }

    gsl_matrix_free(nSigmaU);
    gsl_matrix_free(RedX);
    gsl_matrix_free(RedXtX);
    gsl_matrix_free(V);
    gsl_vector_free(yhat);
    gsl_vector_free(bred);
    
    return 0 ;
}
