/*
 *  GCV_ElasticNet_Eff.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 4/9/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int GCV_ElasticNet_Eff(double * lam1_ptr, double * lam2_ptr, MissBin * MB)
{
	size_t n = MB->G->size1 ;
	size_t d = MB->G->size2 ;
	double all_lam2[4] = {0.01, 0.1, 1.0, 5.0} ;
	size_t n_lam2 = 4 ;
	//int gcvlen = 4 ;
	//double lams[gcvlen] ;
	double all_alpha[5] = {0.25, 0.33, 0.5, 0.67, 0.75} ;
	size_t n_alpha = 5 ;
	//double all_alpha[2] = {0.33, 0.67} ;
	//size_t n_alpha = 2 ;
	//double all_alpha[1] = {0.5} ;
	//size_t n_alpha = 1 ;
	size_t j,k;
	double lam2_opt=0.01, lam1_opt=0.01 ;
	double min_gcv = 1.E8 ;
	double curr_gcv = 0.0 ;
	gsl_vector * bpen = gsl_vector_calloc(d);
	gsl_vector * sepen = gsl_vector_calloc(d);
	gsl_vector * Yc = gsl_vector_calloc(MB->nr_eq99);
	gsl_vector * wtc = gsl_vector_calloc(MB->nr_eq99);
	gsl_matrix * Xc = gsl_matrix_calloc(MB->nr_eq99,d);
	


	for (j=0;j<n_lam2;j++)
	{
		double curr_lam2 = *(all_lam2+j) ;
		for (k=0;k<n_alpha;k++)
		{
			double gcv_num=0.0, gcv_den=0.0 ;
			double curr_alph = *(all_alpha+k) ;
			double curr_lam1 = curr_alph * curr_lam2 / (1. - curr_alph) ;
			
			ElasticNet_Eff(MB,curr_lam1,curr_lam2,bpen,sepen,0);
			GetCompleteYX(Yc,Xc,wtc,MB);
			
			
			double sse = ResidualSSWeighted(Yc,Xc,wtc,bpen,MB);
			//printf("sse = %6.4f\n", sse) ;
			
			double trp = GetTrProjIPW(bpen,Xc,wtc,MB,curr_lam1,curr_lam2,4,bpen);
			//printf("trp = %6.4f\n", trp);
			
			gcv_num = sse ;
			//gcv_num = sse/((double) n) ;
			gcv_den = pow(1.0-(trp/((double) n)),2.0) ;
			
			curr_gcv = gcv_num / gcv_den ;
			//printf("GCV[%6.4e,%6.4e] = %6.4f, sse = %6.4f, trp = %4.2f\n", curr_lam1, curr_lam2, curr_gcv, sse, trp) ;
			//baj_print_vector(bpen);
			if (curr_gcv < min_gcv)
			{
				min_gcv = curr_gcv ;
				lam1_opt = curr_lam1 ;
				lam2_opt = curr_lam2 ;
			}
		}
	}
	
	*lam1_ptr = lam1_opt ;
	*lam2_ptr = lam2_opt ;
	
	gsl_vector_free(bpen);
	gsl_vector_free(sepen);
	gsl_vector_free(Yc);
	gsl_vector_free(wtc);
	gsl_matrix_free(Xc);
	
	return 0 ;
}
