/*
 *  GetCompleteYX.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/23/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int GetCompleteYX(gsl_vector * Yc, gsl_matrix * Xc, gsl_vector * wtc, MissBin * MB)
{
	size_t ntot = MB->G->size1 ;
	size_t d = MB->G->size2 ;
	int i,j;
	int cntr=0 ;
	
	for (i=0;i<ntot;i++)
	{
		double lam1 = MB->lamhat->data[i * MB->lamhat->tda + 0] ;
		double lam2 = MB->lamhat->data[i * MB->lamhat->tda + 1] ;
		double Yi = MB->Y->data[i] ;
		double Ri = MB->R->data[i] ;
		
		if (Ri > 2.5)
		{
			double pihat = (1.0 - lam1) * (1.0 - lam2) ;
			Yc->data[cntr] = Yi ;
			wtc->data[cntr] = 1.0/pihat ;
			
			for (j=0;j<d;j++)
			{
				Xc->data[cntr * Xc->tda + j] = MB->X->data[i * MB->X->tda + j] ;
			}
			cntr++ ;
		}
	}

	//printf("no. completers = %d\n", cntr) ;
	
	return 0 ;
}

