/*
 *  GetTrProj.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/23/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

double GetTrProj(gsl_vector * b, gsl_matrix * X, double lambda, int METH)
{
    int j ;
    size_t d0 = (int) b->size ;
    size_t n = X->size1 ;
    double bg[d0];
    int non0g[d0];
    int g_cntr = 0 ;
	double trproj = 0.0 ;
    
    for (j=0;j<d0;j++)
    {
        double tj = b->data[j];
        if (baj_abs(tj)>1.E-8) 
        {
            *(bg+g_cntr) = tj ;
            *(non0g+g_cntr) = j ;
            g_cntr++;
        }
    }
	
    // Reduced X
    // ---------
    gsl_matrix * RedX = gsl_matrix_calloc(n,g_cntr) ;
    gsl_matrix * XtX = gsl_matrix_calloc(g_cntr, g_cntr) ;
    gsl_matrix * Proj = gsl_matrix_calloc(g_cntr,g_cntr);
    gsl_matrix * nSigmaU = gsl_matrix_calloc(g_cntr, g_cntr) ;
    
    GetReducedX(RedX, non0g, g_cntr, X) ;
    
    gsl_vector_view bbef = gsl_vector_view_array(bg, g_cntr) ;	
    EvalnSigmaU(nSigmaU, lambda, 3.7, &bbef.vector, METH, (double) n) ;
	
    gsl_blas_dgemm(CblasTrans,CblasNoTrans,1.0,RedX,RedX,0.0,XtX);
    gsl_matrix_add(nSigmaU,XtX);
    AunderB(nSigmaU,XtX,Proj);
	
	trproj = 0.0 ;	
    for (j=0;j<g_cntr;j++) trproj += Proj->data[j*Proj->tda + j];
    
    gsl_matrix_free(nSigmaU) ;
    gsl_matrix_free(RedX) ;
    gsl_matrix_free(XtX);
    gsl_matrix_free(Proj);

    return trproj ;
}

/*
double GetTrProj(gsl_vector * b, gsl_matrix * X, double lambda, int METH)
{
    int j ;
    size_t d0 = (int) b->size ;
    size_t n = X->size1 ;
    double bg[d0];
    int non0g[d0];
    int g_cntr = 0 ;
	double trproj = 0.0 ;
    
    for (j=0;j<d0;j++)
    {
        double tj = gsl_vector_get(b,j);
        if (baj_abs(tj)>1.E-8) 
        {
            *(bg+g_cntr) = tj ;
            *(non0g+g_cntr) = j ;
            g_cntr++;
        }
    }
	
    // Reduced X
    // ---------
    gsl_matrix * RedX = gsl_matrix_calloc(n,g_cntr) ;
    gsl_matrix * RedNewX = gsl_matrix_calloc(n,g_cntr) ;
    gsl_matrix * XX = gsl_matrix_calloc(g_cntr, g_cntr) ;
    gsl_matrix * XSX = gsl_matrix_calloc(g_cntr, n);
    gsl_matrix * tX = gsl_matrix_calloc(g_cntr,n);
    gsl_matrix * Proj = gsl_matrix_calloc(n,n);
    gsl_matrix * nSigmaU = gsl_matrix_calloc(g_cntr, g_cntr) ;
    
    GetReducedX(RedX, non0g, g_cntr, X) ;
    
    gsl_vector_view bbef = gsl_vector_view_array(bg, g_cntr) ;	
    EvalnSigmaU(nSigmaU, lambda, 3.7, &bbef.vector, METH, (double) n) ;
	
    gsl_blas_dgemm(CblasTrans,CblasNoTrans,1.0,RedX,RedX,0.0,XX);
    gsl_matrix_add(XX,nSigmaU);
    baj_matrix_transpose(tX,RedX);
    AunderB(XX,tX,XSX);
    gsl_blas_dgemm(CblasNoTrans,CblasNoTrans,1.0,RedX,XSX,0.0,Proj);
	
	trproj = 0.0 ;	
    for (j=0;j<n;j++) trproj += gsl_matrix_get(Proj,j,j);
    
    
    gsl_matrix_free(nSigmaU) ;
    gsl_matrix_free(RedX) ;
    gsl_matrix_free(RedNewX) ;
    gsl_matrix_free(XX);
    gsl_matrix_free(XSX);
    gsl_matrix_free(Proj);
    gsl_matrix_free(tX);

    return trproj ;
}
*/
