/*
 *  LSFit.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/22/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int LSFit(gsl_vector * b, gsl_vector * se, gsl_vector * y, gsl_matrix * X)
{
    size_t n = X->size1 ;
    size_t d = X->size2 ;
    int i,j;
    double sse=0.0;
    gsl_vector * XY = gsl_vector_calloc(d);
    gsl_matrix * XtX = gsl_matrix_calloc(d,d);
    gsl_vector * coef = gsl_vector_calloc(d) ;
    gsl_matrix * diag = gsl_matrix_calloc(d,d);
    gsl_matrix * V = gsl_matrix_calloc(d,d);
    gsl_vector * yhat = gsl_vector_calloc(n);
	gsl_permutation * P = gsl_permutation_calloc(d);
	int signum ;
	
    gsl_matrix_set_identity(diag);

    gsl_blas_dgemm(CblasTrans, CblasNoTrans, 1.0, X, X, 0.0, XtX) ;
    gsl_blas_dgemv(CblasTrans, 1.0, X, y, 0.0, XY); 

	gsl_linalg_LU_decomp(XtX,P,&signum);
	gsl_linalg_LU_solve(XtX, P, XY, coef);
    gsl_vector_memcpy(b, coef) ;
    
    gsl_blas_dgemv(CblasNoTrans, 1.0, X, coef, 0.0, yhat);
    for (i=0;i<n;i++) 
	{
		double resi = y->data[i] - yhat->data[i];
		sse += pow(resi, 2.0);
	}
    double mse = sse/((double) (n-d));

    //AunderB(XtX, diag, V, 0) ;
    for (j = 0 ; j < d ; j++)
    {
        gsl_vector_const_view d_j = gsl_matrix_const_column(diag,j) ;
        gsl_vector_view res_j = gsl_matrix_column(V,j) ;
        gsl_linalg_LU_solve(XtX, P, &d_j.vector, &res_j.vector) ;
    }
	
    for (i=0;i<d;i++)
    {
        double tmp = V->data[i*V->tda + i];
        se->data[i] = sqrt(mse * tmp) ;
    }

    gsl_vector_free(coef) ;
    gsl_matrix_free(XtX) ;
    gsl_vector_free(XY);
    gsl_matrix_free(V);
    gsl_matrix_free(diag);
    gsl_vector_free(yhat);
    gsl_permutation_free(P);
	
    return 0 ;
}
