/*
 *  MatrixSquareRoot.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/19/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int MatrixSquareRoot(gsl_matrix * Root, gsl_matrix * M)
{
    size_t d = M->size1 ;
    gsl_matrix * VarX = gsl_matrix_calloc(d,d);
    gsl_matrix * E = gsl_matrix_calloc(d,d) ;
    gsl_matrix * D = gsl_matrix_calloc(d,d);
    gsl_matrix * ED = gsl_matrix_calloc(d,d);
    gsl_eigen_symmv_workspace * w = gsl_eigen_symmv_alloc(d);
    int j;
        
	gsl_matrix_memcpy(VarX,M);
    gsl_vector_view dvec = gsl_matrix_diagonal(D) ;
    gsl_eigen_symmv (VarX, &dvec.vector, E, w);
    gsl_eigen_symmv_sort (&dvec.vector, E, GSL_EIGEN_SORT_ABS_ASC);
    
    for (j=0;j<d;j++) 
    {
        double tmp = gsl_matrix_get(D,j,j);
        D->data[j * D->tda + j] = sqrt(tmp) ;
    }
    
    gsl_blas_dgemm(CblasNoTrans,CblasNoTrans,1.0,E,D,0.0,ED) ;
    gsl_blas_dgemm(CblasNoTrans,CblasTrans,1.0,ED,E,0.0,Root) ;
    
    gsl_eigen_symmv_free (w);
    gsl_matrix_free(D) ;
    gsl_matrix_free(ED) ;
    gsl_matrix_free(E) ;
    gsl_matrix_free(VarX) ;    
    return 0 ;
}

