/*
 *  NewtonRaphsonFull.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/29/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int NewtonRaphsonFull(gsl_vector * bhat, gsl_vector * sehat, MissBin * MB, gsl_vector * beta_init)
{
	size_t d = MB->G->size2 ;	
	gsl_vector * score = gsl_vector_calloc(d);
	gsl_matrix * hess = gsl_matrix_calloc(d,d);
	gsl_vector * bold = gsl_vector_calloc(d);
	gsl_vector * bnew = gsl_vector_calloc(d);
	gsl_permutation * P = gsl_permutation_calloc(d);
	gsl_vector * newton_step = gsl_vector_calloc(d);
	int signum = 0 ;
	size_t iter = 0 ;
	int MAXITER = 10 ;
	double TOL = 1.E-8 ;
	double absdiff = 100.0 ;
	int j ;
	
	gsl_vector_memcpy(bnew,beta_init);
	printf("[Init] : ");
	baj_print_vector(bnew);
	
	do
	{
		iter++;
		gsl_vector_memcpy(bold,bnew);
		
		
		printf("%d : ", (int) iter);
		baj_print_vector(bold);
		
		
		ScoreHessianFull(score,hess,bold,MB);
		gsl_linalg_LU_decomp(hess,P,&signum);
		gsl_linalg_LU_solve(hess,P,score,newton_step);
		for (j=0;j<d;j++) bnew->data[j] = bold->data[j] - newton_step->data[j] ;
		absdiff = MaxAbsDiff(bnew,bold);
	} while ((iter<MAXITER)&&(absdiff>TOL)) ;

	printf("Number of iterations = %d\n", (int) iter);
	printf("[Final] : ");
	baj_print_vector(bnew);

	gsl_vector_free(score);
	gsl_matrix_free(hess);
	gsl_permutation_free(P);
	gsl_vector_free(bnew);
	gsl_vector_free(bold);
	gsl_vector_free(newton_step);
	
	return 0 ;
}
