/*
 *  NormalizeX.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 4/10/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int NormalizeX(gsl_matrix * X)
{
    int i,j;
    size_t n = X->size1;
    size_t d = X->size2 ;
    gsl_matrix * Y = gsl_matrix_calloc(n,d);
        
		
    for (j=0;j<d;j++)
    {
        double sum =0.0, sum2 = 0.0 ;
		double meanj=0.0, varj = 0.0, sdj = 0.0 ;
		//gsl_vector_view xj = gsl_matrix_column(X,j);
        //double * v_ptr = gsl_vector_ptr(&xj.vector, 0);
        //double meanj = gsl_stats_mean(v_ptr, (&xj.vector)->stride, (&xj.vector)->size) ;
        //double sdj = gsl_stats_sd_m(v_ptr, (&xj.vector)->stride, (&xj.vector)->size, meanj) ;
        //double sdj = gsl_stats_sd_with_fixed_mean(v_ptr, (&xj.vector)->stride, (&xj.vector)->size, meanj) ;
        for (i=0;i<n;i++)
		{
			double tmpx = X->data[i*X->tda + j] ;
			sum += tmpx ;
			sum2 += tmpx*tmpx ;
		}
		meanj = sum / ((double) n) ;
		varj = (sum2/((double) n)) - meanj*meanj ;
		sdj = sqrt(varj) ;
		
		//printf("mean = %5.3f, var = %5.3f sd = %5.3f \n", meanj, varj, sdj) ;
        
        for (i=0;i<n;i++) Y->data[i*Y->tda + j] = (X->data[i*X->tda + j]  - meanj) / sdj;
        
    }

    gsl_matrix_memcpy(X,Y);
    
    gsl_matrix_free(Y);
    return 0 ;
}
