/*
 *  OLSEFFBlock.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/27/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int OLSEFFBlock(double * bhat, double * sehat, MissBin * MB, int * non0ind, int n_nonzero)
{
	int k=0,meth_flag = 0 ;
	size_t d = MB->X->size2 ;
	gsl_vector * Yc = gsl_vector_calloc(MB->nr_eq99);
	gsl_matrix * Xc = gsl_matrix_calloc(MB->nr_eq99, d);
	gsl_vector * wtc = gsl_vector_calloc(MB->nr_eq99); 
	gsl_vector * b0 = gsl_vector_calloc(d);
	gsl_vector * se0 = gsl_vector_calloc(d);
	gsl_vector * bOR = gsl_vector_calloc(d);
	gsl_vector * seOR = gsl_vector_calloc(d);
	gsl_vector * bpen = gsl_vector_calloc(d);
	gsl_vector * sepen = gsl_vector_calloc(d);
	int NSTEP = 25 ;
	double lam1_opt = 0.5 ;
	double lam2_opt = 1.0 ;
	
	GetCompleteYX(Yc,Xc,wtc,MB);
	EstimateBetaEFF(b0,se0,Yc,Xc,wtc,MB);
	
	for (k=0;k<d;k++) 
	{
		bhat[k]  = b0->data[k] ;
		sehat[k]  = se0->data[k] ;	
	}
	
	//printf("b(0) : ") ;
	//baj_print_vector(b0);
	
	
	for (meth_flag=0; meth_flag<4; meth_flag++)
	{		
		double lam = GCV_OLS_Eff(b0,se0,Yc,Xc,wtc,MB,meth_flag,NSTEP);
		OLS_Eff_FITTER(b0,se0,Yc,Xc,wtc,MB,lam,meth_flag,NSTEP,bpen,sepen,0);
		//printf("lamopt(%d) = %5.3f \n", meth_flag, lam) ;
		//printf("b(%d) : ", meth_flag) ;
		//baj_print_vector(bpen);
		
		for (k=0;k<d;k++) 
		{
			bhat[d + meth_flag*d + k]  = bpen->data[k] ;
			sehat[d + meth_flag*d + k]  = sepen->data[k] ;
		}
	}
	
	
	GCV_ElasticNet_Eff(&lam1_opt,&lam2_opt,MB);
	ElasticNet_Eff(MB,lam1_opt,lam2_opt,bpen,sepen,0);
	for (k=0;k<d;k++) 
	{
		bhat[5*d + k]  = bpen->data[k] ;
		sehat[5*d + k]  = sepen->data[k] ;
	}
	
	//printf("b(4) :");
	//baj_print_vector(bpen);
	//baj_print_vector(sepen);
	
	
	// oracle
	
	OLS_Eff_Oracle(bOR, seOR, non0ind, n_nonzero, MB);        
	for (k=0;k<d;k++) 
	{
		bhat[6*d + k]  = bOR->data[k] ;
		sehat[6*d + k]  = seOR->data[k] ;
	}
	//printf("b(T) :");
	//baj_print_vector(bOR);
	
	gsl_vector_free(b0);
	gsl_vector_free(se0);
	gsl_vector_free(bOR);
	gsl_vector_free(seOR);
	gsl_vector_free(bpen);
	gsl_vector_free(sepen);
	gsl_vector_free(Yc);
	gsl_matrix_free(Xc);
	gsl_vector_free(wtc);
	
	return 0 ;
}
