/*
 *  OLSEFFBlockWages11.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 5/28/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int OLSEFFBlockWages11(double * bhat, double * sehat, MissBin * MB, int * non0ind, int n_nonzero)
{
	int k=0 ;
	size_t d = MB->X->size2 ;
	gsl_vector * Yc = gsl_vector_calloc(MB->nr_eq99);
	gsl_matrix * Xc = gsl_matrix_calloc(MB->nr_eq99, d);
	gsl_vector * wtc = gsl_vector_calloc(MB->nr_eq99); 
	gsl_vector * b0 = gsl_vector_calloc(d);
	gsl_vector * se0 = gsl_vector_calloc(d);
	gsl_vector * bOR = gsl_vector_calloc(d);
	gsl_vector * seOR = gsl_vector_calloc(d);
	gsl_vector * bscad = gsl_vector_calloc(d);
	gsl_vector * sescad = gsl_vector_calloc(d);
	gsl_vector * bhard = gsl_vector_calloc(d);
	gsl_vector * sehard = gsl_vector_calloc(d);
	gsl_vector * blasso = gsl_vector_calloc(d);
	gsl_vector * selasso = gsl_vector_calloc(d);
	int NSTEP = 25 ;
	
	GetCompleteYX(Yc,Xc,wtc,MB);
	EstimateBetaEFF(b0,se0,Yc,Xc,wtc,MB);
	
	for (k=0;k<d;k++) 
	{
		bhat[k]  = b0->data[k] ;
		sehat[k]  = se0->data[k] ;	
	}
	
	// scad
	//double lamS = GCV_OLS_Eff(b0,se0,Yc,Xc,wtc,MB,0,NSTEP);
	double lamS = 0.0170 ;
	fprintf(stdout,"lamS = %6.4f\n", lamS);
	OLS_Eff_FITTER(b0,se0,Yc,Xc,wtc,MB,lamS,0,NSTEP,bscad,sescad,1);
	for (k=0;k<d;k++) 
	{
		bhat[d + k]  = bscad->data[k] ;
		sehat[d + k]  = sescad->data[k] ;
	}
	
	// hard
	//double lamH = GCV_OLS_Eff(b0,se0,Yc,Xc,wtc,MB,1,NSTEP);
	double lamH = 0.1007 ;
	fprintf(stdout,"lamH = %6.4f\n", lamH);
	OLS_Eff_FITTER(b0,se0,Yc,Xc,wtc,MB,lamH,1,NSTEP,bhard,sehard,1);
	for (k=0;k<d;k++) 
	{
		bhat[2*d + k]  = bhard->data[k] ;
		sehat[2*d + k]  = sehard->data[k] ;
	}

	// lasso
	//double lamL = GCV_OLS_Eff(b0,se0,Yc,Xc,wtc,MB,2,NSTEP);
	double lamL = 0.009 ;
	fprintf(stdout,"lamL = %6.4f\n",lamL);
	OLS_Eff_FITTER(b0,se0,Yc,Xc,wtc,MB,lamL,2,NSTEP,blasso,selasso,1);
	for (k=0;k<d;k++) 
	{
		bhat[3*d + k]  = blasso->data[k] ;
		sehat[3*d + k]  = selasso->data[k] ;
	}
	
	// oracle
	//OLS_Eff_Oracle(bOR, seOR, non0ind, n_nonzero, MB);        
	for (k=0;k<d;k++) 
	{
		bhat[4*d + k]  = bOR->data[k] ;
		sehat[4*d + k]  = seOR->data[k] ;
	}
	
	gsl_vector_free(b0);
	gsl_vector_free(se0);
	gsl_vector_free(bOR);
	gsl_vector_free(seOR);
	gsl_vector_free(bscad);
	gsl_vector_free(sescad);
	gsl_vector_free(bhard);
	gsl_vector_free(sehard);
	gsl_vector_free(blasso);
	gsl_vector_free(selasso);
	gsl_vector_free(Yc);
	gsl_matrix_free(Xc);
	gsl_vector_free(wtc);
	
	return 0 ;
}

