/*
 *  OLSFullBlockWages.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 5/25/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int OLSFullBlockWages(double * bhat, double * sehat, gsl_vector * Y, gsl_matrix * X, 
	int * non0ind, int n_nonzero)
{
	int k=0 ;
	double lamS=0.0, lamH=0.0, lamL=0.0 ;
	size_t d = X->size2 ;
	gsl_vector * b0 = gsl_vector_calloc(d);
	gsl_vector * se0 = gsl_vector_calloc(d);
	gsl_vector * bOR = gsl_vector_calloc(d);
	gsl_vector * seOR = gsl_vector_calloc(d);
	gsl_vector * bscad = gsl_vector_calloc(d);
	gsl_vector * sescad = gsl_vector_calloc(d);
	gsl_vector * bhard = gsl_vector_calloc(d);
	gsl_vector * sehard = gsl_vector_calloc(d);
	gsl_vector * blasso = gsl_vector_calloc(d);
	gsl_vector * selasso = gsl_vector_calloc(d);
	int NSTEP = 50 ;
	
	// OLS
	LSFit(b0,se0,Y,X);		
	for (k=0;k<d;k++) 
	{
		bhat[k]  = b0->data[k] ;
		sehat[k]  = se0->data[k] ;	
	}
	
	// penalized estimators
	//lamS = GCV_OLS_Full(b0,se0,Y,X,0,NSTEP);
	lamS = 0.0162 ;
	printf("lamS = %6.4f\n", lamS);
	OLS_Full_FITTER(b0,se0,Y,X,lamS,0,NSTEP,bscad,sescad,1);
	for (k=0;k<d;k++) 
	{
		bhat[d + k]  = bscad->data[k] ;
		sehat[d + k]  = sescad->data[k] ;
	}
	
	//lamH = GCV_OLS_Full(b0,se0,Y,X,1,NSTEP);
	lamH = 0.0690 ;
	printf("lamH = %6.4f\n", lamH);
	OLS_Full_FITTER(b0,se0,Y,X,lamH,1,NSTEP,bhard,sehard,1);
	for (k=0;k<d;k++) 
	{
		bhat[2*d + k]  = bhard->data[k] ;
		sehat[2*d + k]  = sehard->data[k] ;
	}

	//lamL = GCV_OLS_Full(b0,se0,Y,X,2,NSTEP);
	lamL = 0.0290 ;
	printf("lamL = %6.4f\n", lamL);
	OLS_Full_FITTER(b0,se0,Y,X,lamL,2,NSTEP,blasso,selasso,1);
	for (k=0;k<d;k++) 
	{
		bhat[3*d + k]  = blasso->data[k] ;
		sehat[3*d + k]  = selasso->data[k] ;
	}

	// oracle
	//OLS_Full_Oracle(bOR, seOR, non0ind, n_nonzero, Y, X);        
	for (k=0;k<d;k++) 
	{
		bhat[4*d + k]  = bOR->data[k] ;
		sehat[4*d + k]  = seOR->data[k] ;
	}
	
	gsl_vector_free(b0);
	gsl_vector_free(se0);
	gsl_vector_free(bOR);
	gsl_vector_free(seOR);
	gsl_vector_free(bscad);
	gsl_vector_free(sescad);
	gsl_vector_free(bhard);
	gsl_vector_free(sehard);
	gsl_vector_free(blasso);
	gsl_vector_free(selasso);
	
	return 0 ;
}

