/*
 *  OLSIPWBlock.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/23/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int OLSIPWBlock(double * bhat, double * sehat, MissBin * MB, int * non0ind, int n_nonzero)
{
	int k=0,meth_flag = 0 ;
	size_t d = MB->X->size2 ;
	gsl_vector * b0 = gsl_vector_calloc(d);
	gsl_vector * se0 = gsl_vector_calloc(d);
	gsl_vector * bOR = gsl_vector_calloc(d);
	gsl_vector * seOR = gsl_vector_calloc(d);
	gsl_vector * bpen = gsl_vector_calloc(d);
	gsl_vector * sepen = gsl_vector_calloc(d);
	gsl_vector * Yc = gsl_vector_calloc(MB->nr_eq99);
	gsl_matrix * Xc = gsl_matrix_calloc(MB->nr_eq99, d);
	gsl_vector * wtc = gsl_vector_calloc(MB->nr_eq99); 
	int NSTEP = 25 ;
	
	GetCompleteYX(Yc,Xc,wtc,MB);
	
	WLS_IPW(b0,se0,Yc,Xc,wtc);		
	for (k=0;k<d;k++) 
	{
		bhat[k]  = b0->data[k] ;
		sehat[k]  = se0->data[k] ;	
	}
	
	// penalized estimators
	
	for (meth_flag=0; meth_flag<3; meth_flag++)
	{		
		//double lam = GCV_OLS_IPW(b0,se0,Y,X,meth_flag,NSTEP);
		//OLS_IPW_FITTER(b0,se0,Y,X,lam,meth_flag,NSTEP,bpen,sepen,1);
		
		for (k=0;k<d;k++) 
		{
			bhat[d + meth_flag*d + k]  = bpen->data[k] ;
			sehat[d + meth_flag*d + k]  = sepen->data[k] ;
		}
	}
	
	
	// oracle
	//OLS_IPW_Oracle(bOR, seOR, non0ind, n_nonzero, Yc, Xc, wtc, MB);        
	for (k=0;k<d;k++) 
	{
		bhat[4*d + k]  = bOR->data[k] ;
		sehat[4*d + k]  = seOR->data[k] ;
	}
	
	gsl_vector_free(Yc);
	gsl_matrix_free(Xc);
	gsl_vector_free(wtc);
	gsl_vector_free(b0);
	gsl_vector_free(se0);
	gsl_vector_free(bOR);
	gsl_vector_free(seOR);
	gsl_vector_free(bpen);
	gsl_vector_free(sepen);
	
	return 0 ;
}

