/*
 *  OLS_Eff_FITTER.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/29/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"
	
int OLS_Eff_FITTER(gsl_vector * b0, gsl_vector * se0, gsl_vector * Yc, 
	gsl_matrix * Xc, gsl_vector * wtc, MissBin * MB, 
    double lambda, int METH, int NSTEP, gsl_vector * bret, gsl_vector * seret, int se_flag)
{
    int j ;
    int d = (int) b0->size ;
    size_t step=0 ;
    double TOL = 1.e-4 ;
    gsl_vector * bnew = gsl_vector_calloc(d);
    gsl_vector * bold = gsl_vector_calloc(d);
    int non0ind[d] ;
	int dnew=0;
    double norm_diff = 10. ;
	
	gsl_vector_memcpy(bnew,b0);
	
    do
    {
        step++ ;
		
        gsl_vector_memcpy(bold,bnew);
		
		/*
        printf("%d : ", (int) step) ;
        for (j=0;j<d;j++) printf("%5.2f ", *(bold->data + j)) ;
        printf("\n") ;
        */
		       
		Shrink_OLS_Eff_Bhat(bnew, MB, bold, lambda, METH, b0);
					
        
        norm_diff = MaxAbsDiff(bold,bnew) ; 

    } while ((norm_diff>TOL) && (step<NSTEP)) ;
        
	dnew=0;
	for (j=0;j<d;j++)
	{
		//double thj = 0.1 * se0->data[j] ;
		double thj = 0.01 ;
		double bj = bnew->data[j] ;
		double bhj = bj ;
		
		if (baj_abs(bj) < thj) bhj = 0.0 ;
		else
		{
			non0ind[dnew] = j ;
			dnew += 1 ;
		}
		bret->data[j] = bhj ;
	}
    
	gsl_vector_set_zero(seret);
	
	
	if ((dnew>0)&&(se_flag==1))
	{
		FindPenStdErrorsOLSEff(seret, bnew, non0ind, dnew, lambda, METH, Yc, Xc, wtc, MB, b0) ;
    }
	
	
    gsl_vector_free(bold);
    gsl_vector_free(bnew);
    
    return 0 ;
}


