/*
 *  OLS_Eff_FITTER_Old.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 4/4/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int OLS_Eff_FITTER_Old(gsl_vector * b0, gsl_vector * se0, gsl_vector * Yc, 
	gsl_matrix * Xc, gsl_vector * wtc, MissBin * MB, 
    double lambda, int METH, int NSTEP, gsl_vector * bret, gsl_vector * seret, int se_flag)
{
    int j ;
    int d = (int) b0->size ;
    int d_new = (int) b0->size ;
    int d_old=0, d_cntr=0 ;
    size_t step=0 ;
    //size_t n = Y->size ;
    double TOL = 1.e-4 ;
    double th_new[d] ;
    double th_old[d] ;
    double beta_new[d] ;
    double beta_old[d] ;
    gsl_vector * bnew = gsl_vector_calloc(d);
    gsl_vector * bold = gsl_vector_calloc(d);
    int non0ind_new[d] ;
    int non0ind_old[d] ;
    double norm_diff = 10. ;
	
	d_cntr=0;
	for (j=0;j<d;j++)
    {
        double betaj = b0->data[j] ;
        double th0 = 0.5 * se0->data[j];
        if (baj_abs(betaj)>th0)
        {
            bnew->data[j] = betaj;
            *(non0ind_new+d_cntr) = j ;
            *(beta_new+d_cntr) = betaj ;
            *(th_new+d_cntr) = th0 ;
            d_cntr++;
        }
    }
    d_new = d_cntr;

    do
    {
        step++ ;
		
        gsl_vector_set_zero(bold);
        for (j=0;j<d_new;j++)
        {
            *(beta_old+j) = *(beta_new+j) ;
            *(th_old+j) = *(th_new+j) ;
            *(non0ind_old+j) = *(non0ind_new+j) ;
            bold->data[*(non0ind_new+j)] = *(beta_new+j);
        }
        d_old = d_new ;
        
		/*
        printf("%d : ", (int) step) ;
        for (j=0;j<d_old;j++) printf("%5.2f ", *(beta_old+j)) ;
        printf("\n") ;
        */
		/*
        if (se_flag==1)
		{
			printf("%d : ", (int) step) ;
			for (j=0;j<bold->size;j++) printf("%4.2f ", *(bold->data+j)) ;
			printf("\n") ;
		}
		*/
		       
        if (d_old < 1)
        {
            fprintf(stderr,"No variables left in model .... break\n") ;
			d_new = 0;
			gsl_vector_set_zero(bnew);
			break ;
        }
        else 
		{
			gsl_vector * bred_old = gsl_vector_calloc(d_old);
			gsl_vector * bred_new = gsl_vector_calloc(d_old);
			
			for (j=0;j<d_old;j++) bred_old->data[j] = beta_old[j];
			
			//Shrink_OLS_Eff_Bhat(bred_new, MB, bred_old, d_old, non0ind_old, lambda, METH);
			
			for (j=0;j<d_old;j++) beta_new[j] = bred_new->data[j] ;
			
			gsl_vector_free(bred_old);
			gsl_vector_free(bred_new);
		}
		
        d_cntr=0;
        gsl_vector_set_zero(bnew);
        for (j=0;j<d_old;j++) 
        {
            double betaj = *(beta_new+j) ;
            if (baj_abs(betaj)>*(th_old+j))
            { 
                bnew->data[*(non0ind_old+j)] = betaj ;
                *(non0ind_new+d_cntr) = *(non0ind_old+j) ;
                *(beta_new+d_cntr) = betaj ;
                d_cntr++;
            }
        }
        d_new = d_cntr;
        
        if (d_new>0) 
		{
			
			Find_OLS_Eff_Thresholds(th_new, d_new, non0ind_new, Yc, Xc, wtc, MB) ;
		}
        norm_diff = MaxAbsDiff(bold,bnew) ; 

    } while ((norm_diff>TOL) && (step<NSTEP)) ;
        
    gsl_vector_memcpy(bret, bnew) ;
	gsl_vector_set_zero(seret);
	
	if ((d_new>0)&&(se_flag==1))
	{
		FindPenStdErrorsOLSEff(seret, bnew, non0ind_new, d_new, lambda, METH, Yc, Xc, wtc, MB, b0) ;
    }
	
    gsl_vector_free(bold);
    gsl_vector_free(bnew);
    
    return 0 ;
}

int Find_OLS_Eff_Thresholds(double * th_new, int d_new, int * non0ind_new, 
	gsl_vector * Yc, gsl_matrix * Xc, gsl_vector * wtc, MissBin * MB) 
{
	int j ;
	size_t nc = Xc->size1 ;
	gsl_vector * bols = gsl_vector_calloc(d_new);
	gsl_vector * seols = gsl_vector_calloc(d_new);
	gsl_matrix * RedX = gsl_matrix_calloc(nc, d_new);
            
	GetReducedX(RedX, non0ind_new, d_new, Xc) ; // new reduced X
            
	WLS_IPW(bols,seols,Yc,RedX,wtc);
	            
	for (j=0;j<d_new;j++) *(th_new + j) = 0.5 * seols->data[j];
                
	gsl_matrix_free(RedX);
	gsl_vector_free(bols);
	gsl_vector_free(seols);

	return 0 ;
}
