/*
 *  OLS_Eff_Oracle.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/30/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int OLS_Eff_Oracle(gsl_vector * bOR, gsl_vector * seOR, int * ind_keep, int len_keep, 
	MissBin * MB)
{
	int j;
	size_t n = MB->Y->size ;
	MissBin * MB_red = (MissBin *)malloc(sizeof(MissBin));
	gsl_vector * bred = gsl_vector_calloc(len_keep);
	gsl_vector * sered = gsl_vector_calloc(len_keep);
	
	//printf("Eff Oracle\n");
	
	InitAllocMissBin((int) n,len_keep,MB_red);
	GetReducedX(MB_red->X,ind_keep,len_keep,MB->X);
	GetReducedX(MB_red->G,ind_keep,len_keep,MB->G);
	MB_red->Y = MB->Y ;
	MB_red->R = MB->R ;
	MB_red->nr_eq1 = MB->nr_eq1 ;
	MB_red->nr_eq2 = MB->nr_eq2 ;
	MB_red->nr_eq99 = MB->nr_eq99 ;
	
	gsl_vector * Yc = gsl_vector_calloc(MB_red->nr_eq99);
	gsl_matrix * Xc = gsl_matrix_calloc(MB_red->nr_eq99,len_keep);
	gsl_vector * wtc = gsl_vector_calloc(MB_red->nr_eq99);
	
	EstimatePsi(MB_red);
	UpdateLambda(MB_red);
	EstimateTheta(MB_red);
	GetCompleteYX(Yc,Xc,wtc,MB_red);
	EstimateBetaEFF(bred,sered,Yc,Xc,wtc,MB_red);
	
	for (j=0;j<len_keep;j++)
	{
		bOR->data[*(ind_keep+j)] = bred->data[j];
		seOR->data[*(ind_keep+j)] = sered->data[j];
	}
	
	gsl_vector_free(bred);
	gsl_vector_free(sered);
	gsl_vector_free(Yc);
	gsl_matrix_free(Xc);
	gsl_vector_free(wtc);
	free(MB_red);
	
	return 0;
}

