/*
 *  OLS_Full_FITTER.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/21/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 * 8 March 2007 : rewrite FITTER to use MM algorithm
 */

#include "coarse.h"

int Find_OLS_Full_Thresholds(double * th_new, int d_new, int * non0ind_new, 
	gsl_vector * Y, gsl_matrix * X) ;
int OLS_Full_FITTER(gsl_vector * b0, gsl_vector * se0, gsl_vector * Y, gsl_matrix * X, 
    double lambda, int METH, int NSTEP, gsl_vector * bret, gsl_vector * seret, int se_flag)
{
    int j ;
    int d = (int) b0->size ;
    int dnew = d ;
    size_t step=0 ;
    //size_t n = Y->size ;
    double TOL = 1.e-6 ;
    gsl_vector * bnew = gsl_vector_calloc(d);
    gsl_vector * bold = gsl_vector_calloc(d);
    int non0ind[d] ;
    double norm_diff = 10. ;

	gsl_vector_memcpy(bnew,b0);
	
    do
    {
        step++ ;
		gsl_vector_memcpy(bold,bnew);
        
		/*
        printf("%d : ", (int) step) ;
        for (j=0;j<d_old;j++) printf("%6.4f ", *(beta_old+j)) ;
        printf("\n") ;
        */
		
        Shrink_OLS_Full_Bhat(bnew,Y,X,bold,lambda,METH,b0);
        
        
        norm_diff = MaxAbsDiff(bold,bnew) ; // max absolute difference

    } while ((norm_diff>TOL) && (step<NSTEP)) ;
        
	dnew=0;
	for (j=0;j<d;j++) 
    {
		double bj = gsl_vector_get(bnew,j) ;
		//double thj = 0.25 * gsl_vector_get(se0,j);
		double thj = 0.01 ;
		double keepj = bj ;
        if (baj_abs(bj) > thj)
		{
			*(non0ind+dnew) = j ;
			dnew += 1 ;
		}
		else
		{
			keepj = 0.0 ;
		}
		bret->data[j] = keepj ;
	}

	gsl_vector_set_zero(seret);
	
	/*
	if ((d_new>0)&&(se_flag==1))
	{
		FindPenStdErrorsOLSFull(seret, bnew, non0ind_new, d_new, Y, X, lambda, METH) ;
    }
	*/
	
    gsl_vector_free(bold);
    gsl_vector_free(bnew);
    
    return 0 ;
}



/*
int Find_OLS_Full_Thresholds(double * th_new, int d_new, int * non0ind_new, 
	gsl_vector * Y, gsl_matrix * X) 
{
	int j ;
	size_t n = X->size1 ;
	gsl_vector * bols = gsl_vector_calloc(d_new);
	gsl_vector * seols = gsl_vector_calloc(d_new);
	gsl_matrix * RedX = gsl_matrix_calloc(n, d_new);
            
	GetReducedX(RedX, non0ind_new, d_new, X) ; // new reduced X
            
	LSFit(bols, seols, Y, RedX) ;
	//baj_print_vector(bols);
            
	for (j=0;j<d_new;j++) *(th_new + j) = 0.5 * seols->data[j];
                
	gsl_matrix_free(RedX);
	gsl_vector_free(bols);
	gsl_vector_free(seols);

	return 0 ;
}
*/
