/*
 *  OLS_Full_Oracle.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/23/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int OLS_Full_Oracle(gsl_vector * bOR, gsl_vector * seOR, int * ind_keep, int len_keep, 
	gsl_vector * Y, gsl_matrix * X)
{
	int j;
	size_t n = Y->size ;
	gsl_matrix * RedX = gsl_matrix_calloc(n,len_keep);
	gsl_vector * bred = gsl_vector_calloc(len_keep);
	gsl_vector * sered = gsl_vector_calloc(len_keep);
	
	GetReducedX(RedX, ind_keep, len_keep, X);
	
	LSFit(bred, sered, Y, RedX);
	
	for (j=0;j<len_keep;j++)
	{
		bOR->data[*(ind_keep+j)] = bred->data[j];
		seOR->data[*(ind_keep+j)] = sered->data[j];
	}
	
	gsl_matrix_free(RedX);
	gsl_vector_free(bred);
	gsl_vector_free(sered);
	
	return 0;
}

