/*
 *  PredictVmissLinearly.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/28/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int PredictVmissLinearly_for_R1(gsl_matrix * alpha, gsl_matrix * tau_sq, MissBin * MB)
{
	size_t d = MB->X->size2 ;
	size_t n = MB->X->size1 ;
	gsl_matrix * Z_tmp = gsl_matrix_calloc(n,d); // int,Y,X3,...,X10
	gsl_matrix * ZtZ = gsl_matrix_calloc(d,d);
	gsl_matrix * ZtY = gsl_matrix_calloc(d,2);
	gsl_matrix * Y_tmp = gsl_matrix_calloc(n,2);
	gsl_matrix * a_tmp = gsl_matrix_calloc(d,2);
	gsl_matrix * Yhat = gsl_matrix_calloc(n,2);
	gsl_matrix * tau2 = gsl_matrix_calloc(2,2);
	gsl_matrix * ehat = gsl_matrix_calloc(n,2);
	int i,j ;
	
	for (i=0;i<n;i++)
	{
		Y_tmp->data[i*Y_tmp->tda + 0] = MB->X->data[i * MB->X->tda + 0] ;
		Y_tmp->data[i*Y_tmp->tda + 1] = MB->X->data[i * MB->X->tda + 1] ;
		
		Z_tmp->data[i*Z_tmp->tda + 0] = 1.0 ;
		Z_tmp->data[i*Z_tmp->tda + 1] = MB->Y->data[i] ;
		for (j=0;j<(d-2);j++)
		{
			Z_tmp->data[i*Z_tmp->tda + 2 + j] = MB->X->data[i * MB->X->tda + 2 + j] ;
		}
	}

	gsl_blas_dgemm(CblasTrans,CblasNoTrans,1.0,Z_tmp,Z_tmp,0.0,ZtZ);
	gsl_blas_dgemm(CblasTrans,CblasNoTrans,1.0,Z_tmp,Y_tmp,0.0,ZtY);
	AunderB(ZtZ,ZtY,a_tmp);
	/*
	printf("a_tmp = \n");
	baj_print_matrix(a_tmp);
	*/
	gsl_blas_dgemm(CblasNoTrans,CblasNoTrans,1.0,Z_tmp,a_tmp,0.0,Yhat);

	gsl_matrix_memcpy(ehat,Y_tmp);
	gsl_matrix_sub(ehat,Yhat);
	gsl_blas_dgemm(CblasTrans,CblasNoTrans,1.0,ehat,ehat,0.0,tau2);
	gsl_matrix_scale(tau2,1./((double) n-d));
	
	/*
	printf("tau2 = \n");
	baj_print_matrix(tau2);
	*/
	
	gsl_matrix_memcpy(alpha,a_tmp);
	gsl_matrix_memcpy(tau_sq, tau2);
	
	gsl_matrix_free(Yhat);
	gsl_matrix_free(ZtZ);
	gsl_matrix_free(ZtY);
	gsl_matrix_free(Z_tmp);
	gsl_matrix_free(Y_tmp);
	gsl_matrix_free(a_tmp);
	gsl_matrix_free(tau2);
	gsl_matrix_free(ehat);
	
	return 0 ;
}
