/*
 *  PredictVmissLinearly_for_R2.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/28/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int PredictVmissLinearly_for_R2(gsl_vector * alpha, double * tau_sq, MissBin * MB)
{
	size_t d = MB->X->size2 ;
	size_t n = MB->X->size1 ;
	gsl_matrix * Z_tmp = gsl_matrix_calloc(n,d+1); // int, Y, X2,X3,...,X10
	gsl_vector * Y_tmp = gsl_vector_calloc(n);
	gsl_vector * a_tmp = gsl_vector_calloc(d+1);
	gsl_vector * ase_tmp = gsl_vector_calloc(d+1);
	gsl_vector * Yhat = gsl_vector_calloc(n);
	double tau2 = 0.0 ;
	
	int i,j ;
	
	for (i=0;i<n;i++)
	{
		Y_tmp->data[i] = MB->X->data[i * MB->X->tda + 0] ;
		Z_tmp->data[i*Z_tmp->tda + 0] = 1.0 ;
		Z_tmp->data[i*Z_tmp->tda + 1] = MB->Y->data[i] ;
		for (j=0;j<(d-1);j++)
		{
			Z_tmp->data[i*Z_tmp->tda + 2 + j] = MB->X->data[i * MB->X->tda + 1 + j] ;
		}
	}
	
	LSFit(a_tmp,ase_tmp,Y_tmp,Z_tmp);
	
	gsl_blas_dgemv(CblasNoTrans,1.0,Z_tmp,a_tmp,0.0,Yhat);
	
	for (i=0;i<n;i++)
	{
		tau2 += pow(Y_tmp->data[i] - Yhat->data[i], 2.0);
	}
	tau2 = tau2/((double) (n-d-1));
	
	*tau_sq = tau2 ;
	
	gsl_vector_memcpy(alpha,a_tmp);
	//baj_print_vector(a_tmp);
	//baj_print_vector(ase_tmp);
	
	gsl_vector_free(Yhat);
	gsl_matrix_free(Z_tmp);
	gsl_vector_free(Y_tmp);
	gsl_vector_free(a_tmp);
	gsl_vector_free(ase_tmp);
	
	return 0 ;
}

