/*
 *  R1_PredictiveFunction.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/28/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 * Vobs is assumed to be length d-1
 * alpha_R1 is d-by-2 matrix
 */

#include "coarse.h"

int R1_PredictiveFunction(gsl_vector * cm1, gsl_matrix * cm2, gsl_matrix * alpha_R1, 
	gsl_matrix * tau_sq_R1, gsl_vector * Vobs)
{
	int j,k ;

	gsl_vector * pred = gsl_vector_calloc(2); 
	gsl_matrix * pred2 = gsl_matrix_calloc(2,2);
	gsl_vector * Vobs_new = gsl_vector_calloc(Vobs->size + 1);
	
	Vobs_new->data[0] = 1.0 ;
	for (j=0;j<(Vobs->size);j++) Vobs_new->data[1+j] = Vobs->data[j] ;
	
	//baj_print_matrix(alpha_R1);
	//baj_print_vector(Vobs_new);
	gsl_blas_dgemv(CblasTrans,1.0,alpha_R1,Vobs_new,0.0,pred);
	
	for (j=0;j<2;j++) 
	{
		for (k=0;k<2;k++) pred2->data[j*pred2->tda + k] = pred->data[j] * pred->data[k] ;
	}
	gsl_matrix_add(pred2,tau_sq_R1);
	
	gsl_vector_memcpy(cm1,pred);
	gsl_matrix_memcpy(cm2,pred2);
	
	
	gsl_vector_free(pred);
	gsl_matrix_free(pred2);
	gsl_vector_free(Vobs_new);
	return 0 ;
}

