/*
 *  R2_IthContr_to_Proj.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/29/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 * score is d-by-1
 * beta is d-by-1
 * cm1 = E(X_1|Vobs) = scalar
 * cm2 = E(X_1^2|Vobs) = scalar
 * Vobs = (Y,X_2,X_3,...,X_d) = d-by-1
 */

#include "coarse.h"

int R2_IthContr_to_Proj(gsl_vector * score, gsl_vector * beta, double cm1, double cm2, 
	gsl_vector * Vobs)
{
	size_t d = beta->size ;
	double Y = Vobs->data[0] ;
	double mu = 0.0; // X_obs * beta_obs
	int j ;
	
	mu = cm1 * beta->data[0] ;
	for (j=1;j<d;j++) mu += Vobs->data[j] * beta->data[j] ;
	
	score->data[0] = -1.0 * cm1 * Y + cm2 * beta->data[0] ;
	for (j=1;j<d;j++) score->data[0] += cm1 * Vobs->data[j] * beta->data[j] ;
	
	for (j=1;j<d;j++) score->data[j] = -1.0 * Vobs->data[j] * (Y - mu) ;
	
	return 0 ;
}
