/*
 *  R2_PredictiveFunction.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/28/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

// Vobs assumed to be length d = (Y,X_2,X_3,...,X_d)
// alpha_R2 assumed to be length d+1 = (alpha_0,alpha_Y,alpha_X2,...,alpha_Xd)
//


#include "coarse.h"

int R2_PredictiveFunction(double * cm1, double * cm2, gsl_vector * alpha_R2, double tau_sq_R2, gsl_vector * Vobs)
{
	int j ;
	
	size_t d = Vobs->size ;
	double pred = alpha_R2->data[0] ;
	double pred2 = 0.0 ;
	for (j=0;j<d;j++) pred += alpha_R2->data[j+1] * Vobs->data[j] ;
	
	pred2 = tau_sq_R2 + pow(pred,2.0) ;
	
	
	*cm1 = pred ;
	*cm2 = pred2 ;
	
	return 0 ;
}

