/*
 *  ResidualSSWeighted.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/30/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

double ResidualSSWeighted(gsl_vector * Yc,gsl_matrix * Xc,gsl_vector * wtc,
	gsl_vector * beta, MissBin * MB)
{
	double sse=0.0;
	int i;
	size_t nc = Yc->size ;
	double denom=0.0;
	
	gsl_vector * mu = gsl_vector_calloc(nc);
	
	gsl_blas_dgemv(CblasNoTrans,1.0,Xc,beta,0.0,mu);
	
	for (i=0;i<nc;i++)
	{
		//double lam1 = MB->lamhat->data[i * MB->lamhat->tda + 0] ;
		//double lam2 = MB->lamhat->data[i * MB->lamhat->tda + 1] ;
		double res = Yc->data[i] - mu->data[i] ;
		//double wt = 1./((1.-lam1)*(1.-lam2));
		double wt = wtc->data[i] ;
		sse += res*res*wt ;
		denom += wt ;
	}
	
	sse = sse/denom ;
	
	gsl_vector_free(mu);
	return sse ;
}

