/*
 *  SandwichMatrix.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/21/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int SandwichEstimate(gsl_matrix * V, gsl_matrix * A, gsl_matrix * B)
{
	int j ;
	size_t d = A->size1 ;
	gsl_matrix * AInv = gsl_matrix_calloc(d,d);
	gsl_matrix * AInvB = gsl_matrix_calloc(d,d);
	gsl_matrix * Diag = gsl_matrix_calloc(d,d);
	gsl_matrix * LocalV = gsl_matrix_calloc(d,d);
	
	for (j=0;j<d;j++) Diag->data[j*Diag->tda + j] = 1.0 ;

	AunderB(A,Diag,AInv);
	
	gsl_blas_dgemm(CblasNoTrans,CblasNoTrans,1.0,AInv,B,0.0,AInvB);
	gsl_blas_dgemm(CblasNoTrans,CblasNoTrans,1.0,AInvB,AInv,0.0,LocalV);
	
	gsl_matrix_memcpy(V,LocalV);
	
	gsl_matrix_free(AInv);
	gsl_matrix_free(AInvB);
	gsl_matrix_free(Diag);
	gsl_matrix_free(LocalV);
	return 0 ;
}

