/*
 *  ScoreHessianIPWReduced.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/29/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int ScoreHessianEffReduced(gsl_vector * score, gsl_matrix * hess, 
	gsl_vector * beta_old, MissBin * MB)
{
	size_t n = MB->G->size1 ;
	size_t d = MB->G->size2 ;	
	gsl_vector * score_local = gsl_vector_calloc(d);
	gsl_matrix * hess_local = gsl_matrix_calloc(d,d);
	gsl_vector * proj_local = gsl_vector_calloc(d);
	
	ScoreHessianIPW(score_local,hess_local,beta_old,MB,proj_local);
	
	gsl_vector_memcpy(proj_local,MB->L2);
	gsl_vector_sub(score_local,proj_local);
	
	gsl_vector_memcpy(score,score_local);
	gsl_matrix_memcpy(hess,hess_local);
	
	
	gsl_vector_free(proj_local);
	gsl_vector_free(score_local);
	gsl_matrix_free(hess_local);
	
	return 0 ;
}

