/*
 *  ScoreHessianFull.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/29/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int ScoreHessianFull(gsl_vector * score, gsl_matrix * hess, gsl_vector * beta, MissBin * MB)
{
	int j ;
	//size_t n = MB->X->size1 ;
	size_t d = MB->X->size2 ;	
	
	gsl_vector * XtY = gsl_vector_calloc(d);
	gsl_matrix * XtX = gsl_matrix_calloc(d,d);
	gsl_vector * XtXb = gsl_vector_calloc(d);
	gsl_vector * score_local = gsl_vector_calloc(d);
	
	
	gsl_blas_dgemv(CblasTrans,1.0,MB->X,MB->Y,0.0,XtY);
	gsl_blas_dgemm(CblasTrans,CblasNoTrans,1.0,MB->X,MB->X,0.0,XtX);
	gsl_blas_dgemv(CblasNoTrans,1.0,XtX,beta,0.0,XtXb);
	
	for (j=0;j<d;j++) score_local->data[j] = XtXb->data[j] - XtY->data[j] ;
	gsl_matrix_memcpy(hess,XtX);
	gsl_vector_memcpy(score,score_local);
	
	
	gsl_vector_free(XtY);
	gsl_matrix_free(XtX);
	gsl_vector_free(XtXb);
	gsl_vector_free(score_local);
	
	return 0 ;
}

