/*
 *  ShootingAlgRank.c
 *  RankVS
 *
 *  Created by Brent Johnson on 2/28/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "rvs.h"

int ShootingAlgRank(gsl_vector * b0, gsl_vector * Y, gsl_matrix * X, double lambda, 
	gsl_vector * wtvec, gsl_vector * bret, gsl_vector * seret, int se_flag)
{
	size_t d = X->size2 ;
	size_t n = X->size1 ;
	size_t j ;
	size_t step=0;
	double TOL = 1.E-6;
	double diff = 10.0;
	size_t MAXITER = 15 ;
	gsl_vector * bold = gsl_vector_calloc(d);
	gsl_vector * bnew = gsl_vector_calloc(d);
	
	for (j=0;j<d;j++) bnew->data[j] = b0->data[j] ;
	
    do
    {
        step++ ;
		for (j=0;j<d;j++) bold->data[j] = bnew->data[j] ;
		
		
        printf("R %d : ", (int) step) ;
        for (j=0;j<d;j++) printf("%5.2f ", *(bold->data+j)) ;
        printf("\n") ;
		
		//ShootBeta_Rank(bnew,Y,X,lambda,wtvec,bold);
		ShootBeta_Rank_Intensive(bnew,Y,X,lambda,wtvec,bold);
		
		
		diff = MaxAbsDiff(bnew,bold);
		printf("diff[%d] = %6.3f\n", (int) step, diff);
	} while ((diff>TOL) && (step<MAXITER)) ;
	

	for (j=0;j<d;j++) bret->data[j] = bnew->data[j] ;

	gsl_vector_free(bold);
	gsl_vector_free(bnew);
	
	return 0 ;
}

