/*
 *  Shrink_OLS_Eff_Bhat.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 4/4/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int Shrink_OLS_Eff_Bhat(gsl_vector * beta_new, MissBin * MB, 
	gsl_vector * bvec, double lambda, int METH, gsl_vector * b0)
{
	size_t n = MB->G->size1 ;
	size_t d = MB->G->size2 ;
	gsl_vector * score = gsl_vector_calloc(d);
	gsl_matrix * I0 = gsl_matrix_calloc(d,d);
	gsl_matrix * nSigmaU = gsl_matrix_calloc(d, d) ;
	gsl_permutation * P = gsl_permutation_calloc(d);
	gsl_vector * b_step = gsl_vector_calloc(d);
	int j=0;
	int signum=0;
	
	//printf("Shrinking ...\n");
	//printf("(Shrinking) ScoreHess\n");
	
	//ScoreHessianEffReduced(score,I0,bvec,MB);
	ScoreHessianIPW(score,I0,bvec,MB,MB->L2);
	//printf("(Shrinking) Finish ScoreHess\n");

	/*
	printf("score = ");
	baj_print_vector(score);
	*/
	
	EvalnSigmaU2(nSigmaU, lambda, 3.7, bvec, METH, (double) n, b0) ; 
        
	gsl_blas_dgemv(CblasNoTrans,1.0,nSigmaU,bvec,1.0,score);
	/*
	printf("score + penalty = ");
	baj_print_vector(score);
	*/
	
	gsl_matrix_add(I0,nSigmaU) ; // (I0 + nSigmaU)
	gsl_linalg_LU_decomp(I0,P,&signum);
	gsl_linalg_LU_solve(I0,P,score,b_step);
	/*
	printf("b_step = ");
	baj_print_vector(b_step);
	*/
	for (j=0;j<d;j++) 
	{
		double bx = *(bvec->data+j) - b_step->data[j] ;
		*(beta_new->data+j) = bx ;
	}
	
	
	gsl_matrix_free(nSigmaU);
	gsl_permutation_free(P);
	gsl_vector_free(score);
	gsl_matrix_free(I0);
	gsl_vector_free(b_step);
	
	return 0 ;
}

