/*
 *  Shrink_OLS_Full_Bhat.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/8/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int Shrink_OLS_Full_Bhat(gsl_vector * b_new, gsl_vector * Y, gsl_matrix * X, 
	gsl_vector * b_old, double lambda, int METH, gsl_vector * b0)
{
	size_t n = X->size1 ;
	size_t d = X->size2 ;
	int signum = 0;
	gsl_matrix * nSigmaU = gsl_matrix_calloc(d, d) ;
	gsl_matrix * XtX = gsl_matrix_calloc(d, d);
	gsl_vector * XtY = gsl_vector_calloc(d);
	gsl_permutation * P = gsl_permutation_calloc(d);
	
	//int j;
	
	EvalnSigmaU2(nSigmaU, lambda, 3.7, b_old, METH, (double) n, b0) ; // Find nSigmaU
        
	gsl_blas_dgemv(CblasTrans, 1.0, X, Y, 0.0, XtY) ; // X'Y
	gsl_blas_dgemm(CblasTrans, CblasNoTrans, 1.0, X, X, 0.0, XtX) ; // X'X
	gsl_matrix_add(nSigmaU, XtX) ; // (X'X + nSigmaU)
        
	gsl_linalg_LU_decomp(nSigmaU,P,&signum);
	gsl_linalg_LU_solve(nSigmaU,P,XtY,b_new);
			
	gsl_matrix_free(nSigmaU);
	gsl_matrix_free(XtX);
	gsl_vector_free(XtY);
	gsl_permutation_free(P);

	return 0 ;
}
