/*
 *  SimStudy.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/19/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int SimStudy(const gsl_rng * r, int baj_index)
{
	MissBin * MB = (MissBin *)malloc(sizeof(MissBin));
	int i,j, d = 10 ;
	int n = 250 ;
	int non0ind[d];
	int n_nonzero = 0 ;
    unsigned long int local_seed ;
	int simseeds[2000] ;	
	double bhat_eff[7*d], sehat_eff[7*d] ;
	int mc,MC=100;
	
	ReadSimSeeds(simseeds);
	
	local_seed = (unsigned long int) *(simseeds+baj_index-1);
	gsl_rng_set(r, local_seed) ; // set to the appropriate seed

	InitAllocMissBin(n,d,MB);
	
	for (mc=0;mc<MC;mc++)
	{
		//printf("mc = %d\n",mc);
		SimulateYX(r,MB->Y,MB->X,non0ind,&n_nonzero);
		SimulateRG(r,MB);
		EstimatePsi(MB);
	
		OLSEFFBlock(bhat_eff,sehat_eff,MB,non0ind,n_nonzero);
	
		for (j=0;j<(7*d);j++) fprintf(stdout,"%7.4f ", *(bhat_eff+j));
		fprintf(stdout,"\n");
	}
	
	
	free(MB);
	
	return 0 ;
}

	/*
	int i,j ;
	for (i=0;i<5;i++)
	{
		printf("%d %5.2f ", i, MB->Y->data[i]);
		for (j=0;j<8;j++) printf("%5.2f ", gsl_matrix_get(MB->X,i,j));
		printf("\n");
	}
	printf("\n ------------------------------- \n\n");
	for (i=0;i<5;i++)
	{
		printf("%d %5.2f ", i, MB->R->data[i]);
		for (j=0;j<8;j++) printf("%5.2f ", gsl_matrix_get(MB->G,i,j));
		printf("\n");
	}
	*/

	/*
	int i,j ;
	for (i=0;i<15;i++)
	{
		printf("%d %3.1f ", i, MB->R->data[i]);
		for (j=0;j<2;j++) printf("%5.2f ", gsl_matrix_get(MB->lamhat,i,j));
		printf("\n");
	}
	*/
	