/*
 *  Simulate_Wages11.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 5/28/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int SimulateRG_Wages11(const gsl_rng * r, MissBin * MB)
{
	size_t n = MB->X->size1 ;
	size_t d = MB->X->size2 ;
	double psi1[12] = {-3.0, 0.75, 0.0, 0.0, 0.25, 0.5, 0.25, 0.0, 0.0, 0.25, 0.25, 0.25} ; // wages 1
	double psi2[13] = {-1.5, 0.5, 0.5, 0.75, 0.75, 0.0, 0.0, 0.0, 0.75, 0.75, 0.15, 0.15, 0.15} ; // wages 1
	//double psi1[12] = {-2.0, 0.75, 0.0, 0.0, 0.25, 0.5, 0.25, 0.0, 0.0, 0.25, 0.25, 0.25} ;
	//double psi2[13] = {-3.5, 0.5, 0.5, 0.75, 0.75, 0.0, 0.0, 0.0, 0.75, 0.75, 0.15, 0.15, 0.15} ;
	int cntr1 = 0, cntr2 = 0, cntr3 = 0 ;
	int i,j;
	
	for (j=0;j<d;j++) MB->psi1->data[j] = psi1[j] ;
	for (j=0;j<(d+1);j++) MB->psi2->data[j] = psi2[j] ;
	
	//gsl_vector_view psi1_vec = gsl_vector_view_array(psi1,eight);
	//gsl_vector_view psi2_vec = gsl_vector_view_array(psi2,nine);
	
	for (i=0;i<n;i++)
	{
		//printf("i= %d\n", i);
		double lam1 = 0.5, rate1 = 0.0, unif1 = 0.0 ;
		double tmpR = 0.0 ;
		double lam2 = 0.0 ;
		
		rate1 = *(psi1+0) + *(psi1+1) * MB->Y->data[i] ;
		for (j=0;j<(d-2);j++) 
		{
			//rate1 += *(psi1 + 2 + j) * MB->X->data[i * MB->X->tda + 2 + j] ;
			rate1 += *(psi1 + 2 + j) * gsl_matrix_get(MB->X,i,2+j) ;
		}
		lam1 = 1./(1. + exp(-1.0 * rate1)) ;
		
		unif1 = gsl_ran_flat(r,0.0,1.0);
		//printf("lam1 = %6.3f, unif1 = %6.3f\n", lam1, unif1);
		if (unif1 < lam1) 
		{
			tmpR = 1.0 ;
			
			MB->R->data[i] = tmpR ;
			for (j=0;j<d;j++) 
			{
				double tmpG ;
				if (j<2) tmpG = 0.0 ;
				else tmpG = MB->X->data[i * MB->X->tda + j] ;
				
				MB->G->data[i * MB->G->tda + j] = tmpG ;
			}
			cntr1++ ;
		}
		else
		{
			double rate2 = 0.0, unif2 = 0.0 ;
			
			rate2 = *(psi2+0) + *(psi2+1) * MB->Y->data[i] ;
			for (j=0;j<(d-1);j++) 
			{
				//rate2 += *(psi2 + 2 + j) * MB->X->data[i*MB->X->tda+1+j] ;
				rate2 += *(psi2 + 2 + j) * gsl_matrix_get(MB->X,i,1+j) ;
			}
			
			lam2 = 1./(1. + exp(-1.0 * rate2));
			
			unif2 = gsl_ran_flat(r,0.0,1.0);
			if (unif2 < lam2) 
			{
				tmpR = 2.0 ;
			
				MB->R->data[i] = tmpR ;
				for (j=0;j<d;j++) 
				{
					double tmpG ;
					
					if (j<1) tmpG = 0.0 ;
					else tmpG = MB->X->data[i * MB->X->tda + j] ;
				
					MB->G->data[i * MB->G->tda + j] = tmpG ;
				}
				cntr2++ ;
			}
			else
			{
				tmpR = 99.0 ;
				MB->R->data[i] = tmpR ;
				for (j=0;j<d;j++) 
				{
					MB->G->data[i * MB->G->tda + j] = MB->X->data[i * MB->X->tda + j] ;
				}
				cntr3++ ;
			}	
		}
		
		MB->lamhat->data[i*MB->lamhat->tda + 0] = lam1;
		MB->lamhat->data[i*MB->lamhat->tda + 1] = lam2;
	}
	
	MB->nr_eq1 = cntr1 ;
	MB->nr_eq2 = cntr2 ;
	MB->nr_eq99 = cntr3 ;
	
	fprintf(stderr,"cntr totals = (%d, %d, %d)\n", cntr1, cntr2, cntr3);
	//printf("cntr totals = (%d, %d, %d)\n", MB->nr_eq1, MB->nr_eq2, MB->nr_eq99);
	
	return 0 ;
}

