/*
 *  SimulateYX.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 3/19/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int SimulateYX(const gsl_rng * r, gsl_vector * Y, gsl_matrix * X, 
	int * non0ind, int * n_nonzero)
{
    size_t n = Y->size ;
    size_t d = X->size2 ;
	double truth[10] = {1.25, 1.25, 0.0, 0.0, 0.75, 1.5, 0.75, 0.0, 0.0, 1.0} ;
	//double truth[10] = {1.25, 1.25, 0.0, 0.25, 0.5, 1.0, 0.5, 0.25, 0.0, 1.0} ;
	double sigma = 1.0 ;
    gsl_matrix * Z = gsl_matrix_calloc(n,d);
    gsl_vector * mu = gsl_vector_calloc(n);
	gsl_matrix * SigX = gsl_matrix_calloc(d,d);
	gsl_matrix * VarX = gsl_matrix_calloc(d,d);
	gsl_vector * beta_VarX = gsl_vector_calloc(d);
	double sis_y = 0.0 ;
    int i,j ;
	int g_cntr= 0 ;
	
	g_cntr=0;
	for (j=0;j<d;j++)
	{
		if (baj_abs(truth[j]) > 1.0E-8) 
		{
			*(non0ind+g_cntr) = j ;
			g_cntr++ ;
		}
	}
	*n_nonzero = g_cntr ;
	
	CovarianceX(VarX);
	//baj_print_matrix(VarX);
	MatrixSquareRoot(SigX,VarX);
	
    for (i=0;i<n;i++)
    {
        for (j=0;j<d;j++) Z->data[i * Z->tda + j] = gsl_ran_gaussian(r,1.0);
    }
    
    gsl_blas_dgemm(CblasNoTrans,CblasNoTrans,1.0,Z,SigX,0.0,X) ;
	
	gsl_vector_view tru_vec = gsl_vector_view_array(truth,d);
    gsl_blas_dgemv(CblasNoTrans,1.0,X,&tru_vec.vector,0.0,mu);
    
	gsl_blas_dgemv(CblasNoTrans,1.0,VarX,&tru_vec.vector,0.0,beta_VarX);
	//printf("Beta * VarX = \n");
	//baj_print_vector(beta_VarX);
	
	gsl_blas_ddot(beta_VarX,&tru_vec.vector,&sis_y);
	sis_y = sis_y + sigma * sigma ;
	//printf("sis_y = %6.4f\n", sis_y);
	
    for (i=0;i<n;i++)
    {
        double error = gsl_ran_gaussian(r,1.0);
        Y->data[i] = mu->data[i] + sigma * error ;
    }
    
	gsl_vector_free(beta_VarX);
    gsl_matrix_free(SigX);
	gsl_matrix_free(VarX);
    gsl_matrix_free(Z);
    gsl_vector_free(mu);
	
	return 0 ;
}

