/*
 *  TestShootingAlgOLS.c
 *  RankVS
 *
 *  Created by Brent Johnson on 2/27/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "rvs.h"

int ReadTestMatrix(gsl_vector * Y, gsl_matrix * X);
int TestShootingAlgOLS(void)
{
    size_t n = 100 ;
	size_t d = 8 ;
	gsl_vector * Y = gsl_vector_calloc(n);
	gsl_matrix * X = gsl_matrix_calloc(n,d);
	gsl_vector * bols = gsl_vector_calloc(d);
	gsl_vector * seols = gsl_vector_calloc(d);
	gsl_vector * lasso = gsl_vector_calloc(d);
	gsl_vector * alasso = gsl_vector_calloc(d);
	gsl_vector * se_lasso = gsl_vector_calloc(d);
	gsl_vector * weights = gsl_vector_calloc(d);
	gsl_vector * br = gsl_vector_calloc(d);
	gsl_vector * brl1 = gsl_vector_calloc(d);
	gsl_vector * ser = gsl_vector_calloc(d);
	double tau0 = 0.0 ;
	int j ;
	
	ReadTestMatrix(Y,X);
	LSFit(bols,seols,Y,X);
	for (j=0;j<d;j++)
	{
		printf("b[%d] : %8.5f (%7.5f) \n", j, bols->data[j], seols->data[j]);
	}
	
	//for (j=0;j<d;j++) weights->data[j] = 1.0 ;
	//ShootingAlgOLS(bols,Y,X,0.5,weights,lasso,se_lasso,0);

	//for (j=0;j<d;j++) weights->data[j] = 1.0/baj_abs(bols->data[j]) ;
	//ShootingAlgOLS(bols,Y,X,0.5,weights,alasso,se_lasso,0);
	
	//RankEstimateMcKean(br,ser,&tau0,Y,X);
	//ShootingAlgRank(br,Y,X,0.15,weights,brl1,se_lasso,0);
	
	/*
	for (j=0;j<d;j++)
	{
		printf("b[%d] : %5.2f %5.2f \t %5.2f %5.2f \n", j, bols->data[j], 
			lasso->data[j], br->data[j], brl1->data[j]);
	}
	*/
	
	gsl_vector_free(lasso);
	gsl_vector_free(alasso);
	gsl_vector_free(weights);
	gsl_matrix_free(X);
	gsl_vector_free(Y);
	gsl_vector_free(bols);
	gsl_vector_free(br);
	gsl_vector_free(brl1);
	gsl_vector_free(ser);
	gsl_vector_free(seols);
	gsl_vector_free(se_lasso);
	return 0 ;
}

int ReadTestMatrix(gsl_vector * Y, gsl_matrix * X)
{
    //size_t n = 100 ;
	//size_t d = 9 ;
	FILE * f ;
	gsl_matrix * A = gsl_matrix_calloc(100,9);
	
	f = fopen("/Users/brentjohnson/Documents/ResearchProgs/ModelSelection/TestRLasso2/testdat.txt","r") ;
	if (f==NULL)
	{
		printf("Cannot open ~/ResearchProgs/ModelSelection/TestRLasso2/testdat.txt\n") ;
		exit(8);
	}
	else
	{
		int i,j;
		gsl_matrix_fscanf(f,A);
		
		for (i=0;i<100;i++)
		{
			Y->data[i] = A->data[i * A->tda + 0] ;
			for (j=0;j<8;j++)
			{
				X->data[i * X->tda + j] = A->data[i * A->tda + (j+1)] ; // X[i,j] = A[i,j+1]
			}
		}
	}

    gsl_matrix_free(A);
    fclose(f);
    return 0 ;
}

