/*
 *  WagesAnalysis.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 4/10/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int WagesAnalysis(const gsl_rng * r)
{
	int k,j,d=17 ;
	MissBin * MB = (MissBin *)malloc(sizeof(MissBin));
	double bhat_full[5*d], sehat_full[5*d];
	double bhat_eff[5*d], sehat_eff[5*d] ;
	double bhat_naive[5*d], sehat_naive[5*d];
	int non0ind[d] ;
	int n_nonzero = d ;
	
	for (j=0;j<d;j++) *(non0ind+j) = j ;
	
	printf("Wages Analysis\n");
	InitAllocMissBin(534,d,MB);
	ReadWages(MB);
	
	SimulateRG_Wages(r,MB);
	EstimatePsi(MB);
	
	
	OLSFullBlockWages(bhat_full,sehat_full,MB->Y,MB->X,non0ind,n_nonzero);
	for (j=0;j<d;j++) 
	{
		for (k=0;k<4;k++) fprintf(stdout,"%6.3f (%4.3f) ", *(bhat_full+k*d+j), *(sehat_full+k*d+j));
		//for (k=0;k<4;k++) fprintf(stdout,"%7.4f %7.4f ", *(bhat_full+k*d+j), *(sehat_full+k*d+j));
		fprintf(stdout,"\n");
	}
	fprintf(stdout,"\n\n");
	
	/*
	fprintf(stdout,"\n");
	fprintf(stdout,"Naive Estimates\n");
	OLSNaiveBlock(bhat_naive,sehat_naive,MB,non0ind,n_nonzero);
	for (j=0;j<d;j++) 
	{
		for (k=0;k<4;k++) fprintf(stdout,"%5.2f (%4.2f) ", *(bhat_naive+k*d+j), *(sehat_naive+k*d+j));
		fprintf(stdout,"\n");
	}
	fprintf(stdout,"\n\n");
	*/
	
	OLSEFFBlockWages(bhat_eff,sehat_eff,MB,non0ind,n_nonzero);
	for (j=0;j<d;j++) 
	{
		for (k=0;k<4;k++) fprintf(stdout,"& $%6.3f (%4.3f)$ ", *(bhat_eff+k*d+j), *(sehat_eff+k*d+j));
		fprintf(stdout,"\n");
	}
	
	
	free(MB);
	return 0 ;
}


	/*
	for (i=0;i<10;i++)
	{
		printf("Y[%d] = %6.3f, X1 = %4.1f X2 = %4.1f X3 = %4.1f\n", 
			i, MB->Y->data[i], gsl_matrix_get(MB->X,i,0),gsl_matrix_get(MB->X,i,1),
			gsl_matrix_get(MB->X,i,2));
	}
	
	for (i=0;i<10;i++)
	{
		printf("Y[%d] = %6.3f, X1 = %4.1f X2 = %4.1f X3 = %4.1f R[%d] = %2.f\n", 
			i, MB->Y->data[i], gsl_matrix_get(MB->G,i,0),gsl_matrix_get(MB->G,i,1), 
			gsl_matrix_get(MB->G,i,2),i,MB->R->data[i]);
	}
	*/

