/*
 *  WagesSimulation.c
 *  CoarsenedData
 *
 *  Created by Brent Johnson on 5/18/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "coarse.h"

int WagesSimulation(const gsl_rng * r)
{
	int MC=100 ;
	int mc,i,j,d=12 ;
	int n=534 ;
	MissBin * MB = (MissBin *)malloc(sizeof(MissBin));
	double bhat_eff[5*d], sehat_eff[5*d] ;
	double bhat_naive[5*d], sehat_naive[5*d];
	int non0ind[12] = {0,1,2,3,4,5,6,7,8,9,10,11};
	int n_nonzero = 12 ;
	int simseeds[2000] ;	
	
	fprintf(stderr,"Wages Simulation\n");
	ReadSimSeeds(simseeds);
	InitAllocMissBin(n,d,MB);
	ReadWages(MB);
	
	for (mc=0;mc<MC;mc++)
	{
		unsigned long int local_seed = (unsigned long int) *(simseeds+mc);

		fprintf(stderr,"mc = %d\n", mc) ;
		gsl_rng_set(r, local_seed);
		
		if (mc>0)
		{
			for (i=0;i<n;i++)
			{
				MB->R->data[i] = 0.0 ;
				for (j=0;j<d;j++) MB->G->data[i * MB->G->tda + j] = 0.0 ;
				
				MB->lamhat->data[i * MB->lamhat->tda + 0] = 0.0 ;
				MB->lamhat->data[i * MB->lamhat->tda + 1] = 0.0 ;
			}
		}
		
		SimulateRG_Wages(r,MB);
		EstimatePsi(MB);
	
		OLSEFFBlock(bhat_eff,sehat_eff,MB,non0ind,n_nonzero);
		OLSNaiveBlock(bhat_naive,sehat_naive,MB,non0ind,n_nonzero);
		
		for (j=0;j<(5*d);j++) fprintf(stdout,"%7.4f ", *(bhat_eff+j));
		for (j=0;j<(5*d);j++) fprintf(stdout,"%7.4f ", *(bhat_naive+j));
		
		for (j=0;j<(5*d);j++) fprintf(stdout,"%7.4f ", *(sehat_eff+j));
		for (j=0;j<(5*d);j++) fprintf(stdout,"%7.4f ", *(sehat_naive+j)) ;
		
		fprintf(stdout,"\n");
		

	}
	
	free(MB);
	return 0 ;
}

